#!/bin/bash

function getSessionDir() {
  sessionid=$(cat /runlist.json | python3 -c 'import json,sys;obj=json.load(sys.stdin);print(obj["session"]["uuid"])')
  run_id=$(cat /runlist.json | python3 -c 'import json,sys;obj=json.load(sys.stdin);print(obj["session"]["runUuid"])')
  mkdir -p /results/"$sessionid"/"$run_id"
  sessiondir=/results/$sessionid/$run_id
  echo "$sessiondir"
}

function getResultsDir() {
  resultdir=/results
  if [ -f "$resultdir" ]; then
    rm -rf "$resultdir"
    mkdir -p "$resultdir"
  else
    mkdir -p "$resultdir"
  fi
  echo "$resultdir"
}

function getLogDir() {
  # shellcheck disable=SC2002
  sessionid=$(cat /runlist.json | python3 -c 'import json,sys;obj=json.load(sys.stdin);print(obj["session"]["uuid"])')
  # shellcheck disable=SC2002
  run_id=$(cat /runlist.json | python3 -c 'import json,sys;obj=json.load(sys.stdin);print(obj["session"]["runUuid"])')
  # shellcheck disable=SC2002
  tcname=$(cat /testcase.json | python3 -c 'import json,sys;obj=json.load(sys.stdin);print(obj["name"])')

  dateTimeDir=$(date '+%m%d%Y%H%M%S')
  # shellcheck disable=SC2001
  testname=$(echo "$tcname" | sed -e 's/ /_/g')
  mkdir -p /results/"$sessionid"/"$run_id"/"$testname"/
  mkdir -p /results/"$sessionid"/"$run_id"/"$testname"/"$dateTimeDir"
  logdir=/results/$sessionid/$run_id/$testname/$dateTimeDir
  echo "$logdir"
}

function getTestCaseName() {
  # shellcheck disable=SC2002
  tcname=$(cat /testcase.json | python3 -c 'import json,sys;obj=json.load(sys.stdin);print(obj["name"])')
  echo "$tcname"
}
