import base64
import hashlib
import os
import string
import random


class DataGenerator:

    def __init__(self):
        pass

    @staticmethod
    def id_generator_uppercase(size=6, chars=string.ascii_uppercase + string.digits):
        ...
        return ''.join(random.choice(chars) for _ in range(size))

    @staticmethod
    def id_generator_lowercase(size=6, chars=string.ascii_lowercase + string.digits):
        ...
        return ''.join(random.choice(chars) for _ in range(size))

    @staticmethod
    def calculate_md5(str_to_cal):
        if isinstance(str_to_cal, str):
            str_to_cal = str_to_cal.encode('utf-8')
        return hashlib.md5(str_to_cal).hexdigest()

    @staticmethod
    def calculate_content_md5(body_str):
        base64_md5 = ""
        if isinstance(body_str, str):
            hash_md5 = hashlib.md5(body_str.encode()).digest()
            base64_md5 = base64.b64encode(hash_md5).decode('ascii')
        return base64_md5

    @staticmethod
    def generate_object_name(length=50, path_obj=False):
        if not path_obj:
            return DataGenerator.id_generator_lowercase(size=length)
        else:
            prefix = ''
            path_obj = 'b'
            while len(path_obj) < length:
                prefix += 'a/'
                path_obj = prefix + 'b'

            return path_obj[2:] if len(path_obj) > 3 else path_obj

    @staticmethod
    def generate_bucket_name(context, bucket_prefix=""):
        if bucket_prefix:
            bucket_name = bucket_prefix + DataGenerator().id_generator_lowercase(size=15)
        else:
            bucket_prefix = os.getenv("bucket_prefix")
            bucket_name = bucket_prefix + DataGenerator().id_generator_lowercase(size=15)
        os.environ["bucket_name"] = bucket_name
        context.bucket_name = bucket_name
        return bucket_name
