# encoding: utf-8
# @author: Xiaochun Li
# @file: json_parser.py
# @time: 2022/11/30 21:22
# @desc:

import json


def read_json_file(input_file):
    try:
        with open(input_file, 'r') as f:
            data = json.load(f)
        return data
    except Exception as e:
        return {"error": str(e)}


def read_json_by_key(input_file, key=None):
    try:
        if '.json' in input_file and key is not None:
            file = read_json_file(input_file)
            if key in file.keys():
                return file[key]
            else:
                return 'Please select valid key'

        else:
            return 'Please check filename or key and Filename type should be JSON'
    except Exception as e:
        return str(e)


def update_value_by_key(input_file, key=None, val=None):
    try:
        if '.json' in input_file and key is not None and val is not None:
            file = read_json_file(input_file)
            if key in file.keys():

                file[key] = val
                with open(input_file, "w") as jsonFile:
                    json.dump(file, jsonFile)
                return file
            else:
                return 'Please select valid key'

        else:
            return 'Please check filename or parameters and Filename type should be JSON'

    except Exception as e:
        return str(e)


def add_obj(input_file, obj=None, key=None, val=None):
    try:
        if '.json' in input_file and obj is not None and key is not None and val is not None:
            file = read_json_file(input_file)
            if obj not in file.keys():
                add_obj = {obj: {key: val}}
                file.update(add_obj)
                with open(input_file, "w") as jsonFile:
                    json.dump(file, jsonFile)
                return file
            else:
                return "object already exists"

        else:
            return 'Please check filename or parameters and Filename type should be JSON'
    except Exception as e:
        return str(e)


def add_key_value(input_file, key=None, val=None):
    try:
        if '.json' in input_file and key is not None and val is not None:
            file = read_json_file(input_file)
            if key not in file.keys():
                add_key_val = {key: val}
                file.update(add_key_val)
                with open(input_file, "w") as jsonFile:
                    json.dump(file, jsonFile)
                return file
            else:
                return "key already exist"

        else:
            return 'Please check filename or parameters and Filename type should be JSON'
    except Exception as e:
        return str(e)


def delete_obj(input_file, key=None):
    if '.json' in input_file and key is not None:
        file = read_json_file(input_file)

        if key in file.keys():
            del file[key]
            with open(input_file, "w") as jsonFile:
                json.dump(file, jsonFile)
            return file
        else:
            return 'Please select valid key'

    else:
        return 'Please check filename or parameters and Filename type should be JSON'
