@common_test_suite @common @bucket_acl
Feature: VMware OSE Common Test Suite/Validate Bucket ACL Functionality

  Scenario Outline: Put bucket acl to specific user(same tenant) with FULL_CONTROL permission by AccessControlPolicy body
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Bucket ACL to tenant user <owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get bucket ACL
    Given I am the other tenant user <other_tenant_user>
    Then I get bucket ACL
    Then I list all objects
    Given I am a tenant user <tenant_user>
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Put bucket ACL
      | tenant_user           | object_key        | other_tenant_user     | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu2 | CanonicalUser | FULL_CONTROL       | 200                                | 204                                |

  Scenario Outline: Put bucket acl to specific user(same tenant) with READ permission by AccessControlPolicy body
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Bucket ACL to tenant user <owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get bucket ACL
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Put bucket ACL
      | tenant_user           | object_key        | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu2 | CanonicalUser | READ               | 200                                | 204                                |

  Scenario Outline: Put bucket acl to specific user(same tenant) with WRITE permission by AccessControlPolicy body
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Bucket ACL to tenant user <owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get bucket ACL
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Put bucket ACL
      | tenant_user           | object_key        | other_tenant_user     | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu2 | CanonicalUser | WRITE              | 200                                | 204                                |

  Scenario Outline: Put bucket acl to specific user(same tenant) with WRITE_ACP permission by AccessControlPolicy body
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Bucket ACL to tenant user <owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get bucket ACL
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Put bucket ACL
      | tenant_user           | object_key        | other_tenant_user     | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu2 | CanonicalUser | WRITE_ACP          | 200                                | 204                                |

  Scenario Outline: Put bucket acl to specific user(same tenant) with READ_ACP permission by AccessControlPolicy body
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Bucket ACL to tenant user <owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get bucket ACL
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Put bucket ACL
      | tenant_user           | object_key        | other_tenant_user     | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu2 | CanonicalUser | READ_ACP           | 200                                | 204                                |

  Scenario Outline: Get bucket acl of shared bucket(same tenant) with read_acp permission
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Bucket ACL to tenant user <owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get bucket ACL
    Given I am the other tenant user <other_tenant_user>
    Then I get bucket ACL
    Given I am a tenant user <tenant_user>
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Put bucket ACL
      | tenant_user           | object_key        | other_tenant_user     | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu2 | CanonicalUser | READ_ACP           | 200                                | 204                                |

  @debug_location
  Scenario Outline: Put bucket acl to ALLUsers(same tenant) with FULL_CONTROL permission by AccessControlPolicy body
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Bucket ACL to All Users:<uri>, <owner_id>,<grantee_id>,<grantee_type>,<grantee_permission>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get bucket ACL
    Then I get bucket location
    Given I am the other tenant user <other_tenant_user>
    Then I get bucket ACL
    Then I list all objects
    Given I am a tenant user <tenant_user>
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Put bucket ACL
      | tenant_user           | object_key        | other_tenant_user     | uri                                             | owner_id              | grantee_id            | grantee_type | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu2 | http://acs.amazonaws.com/groups/global/AllUsers | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | Group        | FULL_CONTROL       | 200                                | 204                                |

  Scenario Outline: Put bucket acl to AuthenticatedUsers(same tenant) with FULL_CONTROL permission by AccessControlPolicy body
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Bucket ACL to Authenticated Users:<uri>, <owner_id>,<grantee_id>,<grantee_type>,<grantee_permission>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get bucket ACL
    Given I am the other tenant user <other_tenant_user>
    Then I get bucket ACL
    Then I list all objects
    Given I am a tenant user <tenant_user>
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Put bucket ACL
      | tenant_user           | object_key        | other_tenant_user     | uri                                                       | owner_id              | grantee_id            | grantee_type | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu2 | http://acs.amazonaws.com/groups/global/AuthenticatedUsers | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | Group        | FULL_CONTROL       | 200                                | 204                                |

  @ceph_exclude
  Scenario Outline: Put bucket acl to specific user(different tenant) with FULL_CONTROL permission by AccessControlPolicy body
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Bucket ACL to tenant user <owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get bucket ACL
    Given I am the other tenant user <other_tenant_user>
    Then I get bucket ACL
    Then I list all objects
    Given I am a tenant user <tenant_user>
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Put bucket ACL
      | tenant_user           | object_key        | other_tenant_user     | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto2_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto2_tu1 | vcd-site_ossauto2_tu1 | CanonicalUser | FULL_CONTROL       | 200                                | 204                                |


  Scenario Outline: Put bucket acl with correct content-MD5
    Given I am a tenant user <tenant_user>
    When I Put Bucket ACL with incorrect content-MD5 check: <owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Put bucket ACL with incorrect content-MD5
      | tenant_user           | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu2 | CanonicalUser | WRITE_ACP          | 204                                |

  Scenario Outline: Put bucket acl with empty ACL settings
    Given I am a tenant user <tenant_user>
    When I Put Bucket ACL with empty ACL settings and get the expected status code:<expected_error_message>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Put bucket ACL with empty ACL settings
      | tenant_user           | expected_error_message                                                                                                                        | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | An error occurred (InvalidRequest) when calling the PutBucketAcl operation: Fields are required for resource creation or modification: Owner. | 204                                |