@common_test_suite @common @bucket_basic
Feature: VMware OSE Common Test Suite/Validate Bucket Functionality

  Scenario Outline: Create Bucket with valid name
  """
  Bucket names must be between 3 (min) and 63 (max) characters long.

  Bucket names can consist only of lowercase letters, numbers, dots (.), and hyphens (-).

  Bucket names must begin and end with a letter or number.

  Bucket names must not contain two adjacent periods.

  Bucket names must not be formatted as an IP address (for example, 192.168.5.4).

  Bucket names must not start with the prefix xn--.

    """
    Given I am a tenant user <tenant_user>
    When I created a bucket with specified name <bucket_name>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get bucket location
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Create bucket
      | tenant_user           | bucket_name   | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | api           | 200                                | 204                                |
      | vcd-site_ossauto1_tu1 | api-auto-test | 200                                | 204                                |
      | vcd-site_ossauto1_tu1 | apiautotest   | 200                                | 204                                |
      | vcd-site_ossauto1_tu1 | 0001-api-auto | 200                                | 204                                |
      | vcd-site_ossauto1_tu1 | api-auto-0001 | 200                                | 204                                |
      | vcd-site_ossauto1_tu1 | api.auto.test | 200                                | 204                                |

