@common_test_suite @common @bucket_cors
Feature: VMware OSE Common Test Suite/Validate Bucket Cors Functionality

  Scenario Outline: Add bucket cors for bucket
    Given I am a tenant user <tenant_user>
    When I Add bucket Cors to bucket with template: <bucket_cors_template>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Create bucket with prefix
      | tenant_user           | bucket_cors_template        | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | BUCKET_CORS_GET_TEMPLATE    | 200                                | 204                                |
      | vcd-site_ossauto1_tu1 | BUCKET_CORS_PUT_TEMPLATE    | 200                                | 204                                |
      | vcd-site_ossauto1_tu1 | BUCKET_CORS_HEAD_TEMPLATE   | 200                                | 204                                |
      | vcd-site_ossauto1_tu1 | BUCKET_CORS_POST_TEMPLATE   | 200                                | 204                                |
      | vcd-site_ossauto1_tu1 | BUCKET_CORS_DELETE_TEMPLATE | 200                                | 204                                |
      | vcd-site_ossauto1_tu1 | BUCKET_CORS_DELETE_TEMPLATE | 200                                | 204                                |


  Scenario Outline: Add invalid bucket CORs
    Given I am a tenant user <tenant_user>
    Then I validate bucket cors with wrong argument and template: <bucket_cors_template>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Create bucket with prefix
      | tenant_user           | bucket_cors_template     | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | BUCKET_CORS_GET_TEMPLATE | 204                                |

  Scenario Outline: Delete bucket cors rule
    Given I am a tenant user <tenant_user>
    When I Add bucket Cors to bucket with template: <bucket_cors_template>
    Then I delete bucket CORS and check the status code <bucket_cors_expected_status_code>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: bucket cors
      | tenant_user           | bucket_cors_template     | expected_status_code_delete_bucket | bucket_cors_expected_status_code |
      | vcd-site_ossauto1_tu1 | BUCKET_CORS_GET_TEMPLATE | 204                                | 204                              |

  Scenario Outline: Get bucket cors rule
    Given I am a tenant user <tenant_user>
    When I Add bucket Cors to bucket with template: <bucket_cors_template>
    Then I get bucket CORS
    Then I validate bucket CORs with expected message <expected_message>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: bucket cors
      | tenant_user           | bucket_cors_template     | expected_status_code_delete_bucket | expected_message                                                                                   |
      | vcd-site_ossauto1_tu1 | BUCKET_CORS_GET_TEMPLATE | 204                                | 'AllowedHeaders': ['*'], 'AllowedMethods': ['GET'], 'AllowedOrigins': ['*'], 'MaxAgeSeconds': 3600 |