@common_test_suite @common @bucket_lifecycle_configuration
Feature: VMware OSE Common Test Suite/Validate Bucket Lifecycle Configuration Functionality

  Scenario Outline: Put Bucket lifecycle configuration - non-exist bucket
    Given I am a tenant user <tenant_user>
    When I Add Bucket Lifecycle Configuration <lifecycle_configuration_rule> to non-existing bucket
    Then I verify that the expected message <expected_message> return as expected
    Examples: Bucket lifecycle
      | tenant_user           | lifecycle_configuration_rule                  | expected_message                                                                           |
      | vcd-site_ossauto1_tu1 | {"prefix":"sample_object","status":"Enabled"} | An error occurred (NoSuchBucket) when calling the PutBucketLifecycleConfiguration operatio |

  Scenario Outline: Put Bucket lifecycle configuration with versioning enabled
    Given I am a tenant user <tenant_user>
    When  I create a bucket on default region
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I update bucket's versioning status <versioning_status>
    When I Add Bucket Lifecycle Configuration: <lifecycle_configuration_rule> with filter
    Then I get Bucket lifecycle
    And I validate Bucket lifecycle
    And I delete the bucket
    And I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Bucket Versioning
      | tenant_user           | expected_status_code_create_bucket | expected_status_code_delete_bucket | versioning_status | lifecycle_configuration_rule                  |
      | vcd-site_ossauto1_tu1 | 200                                | 204                                | Enable            | {"prefix":"sample_object","status":"Enabled"} |

  Scenario Outline: Add Bucket lifecycle configuration rule with filter/object
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    When I Add Bucket Lifecycle Configuration: <lifecycle_configuration_rule> with filter
    Then I get Bucket lifecycle
    Then I validate Bucket lifecycle
    Then I get Bucket lifecycle configuration
    Then I delete the bucket
    Examples: Bucket lifecycle
      | tenant_user           | lifecycle_configuration_rule                  | object_key        |
      | vcd-site_ossauto1_tu1 | {"prefix":"sample_object","status":"Enabled"} | sample_object.txt |

  Scenario Outline: Add Bucket lifecycle configuration rule with filter/folder
    Given I am a tenant user <tenant_user>
    When  I create a bucket on default region
    And  I create the folder <folder_name> for one bucket
    When I Add Bucket Lifecycle Configuration: <lifecycle_configuration_rule> with filter
    Then I get Bucket lifecycle
    Then I validate Bucket lifecycle
    Then I get Bucket lifecycle configuration
    Then I delete the bucket
    Examples: Bucket lifecycle
      | tenant_user           | lifecycle_configuration_rule                  | folder_name   |
      | vcd-site_ossauto1_tu1 | {"prefix":"object_folder","status":"Enabled"} | object_folder |

  Scenario Outline: Add Bucket lifecycle configuration rule with prefix
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    When I Add Bucket Lifecycle Configuration: <lifecycle_configuration_rule> with prefix
    Then I get Bucket lifecycle
    Then I validate Bucket lifecycle
    Then I get Bucket lifecycle configuration
    Then I delete the bucket
    Examples: Bucket lifecycle
      | tenant_user           | lifecycle_configuration_rule                  | object_key        |
      | vcd-site_ossauto1_tu1 | {"prefix":"sample_object","status":"Enabled"} | sample_object.txt |

  Scenario Outline: Get Bucket lifecycle has no lifecycle configuration rule
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I validate bucket has no lifecycle configuration
    Then I delete the bucket
    Examples: Bucket lifecycle
      | tenant_user           | object_key        |
      | vcd-site_ossauto1_tu1 | sample_object.txt |

  Scenario Outline: Delete bucket lifecycle has no lifecycle configuration rule
    Given I am a tenant user <tenant_user>
    When  I create a bucket on default region
    Then I delete the lifecycle configuration
    Then I delete the bucket
    Examples: Bucket lifecycle
      | tenant_user           |
      | vcd-site_ossauto1_tu1 |

  Scenario Outline: Delete Bucket lifecycle configuration
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    When I Add Bucket Lifecycle Configuration: <lifecycle_configuration_rule> with prefix
    Then I delete the lifecycle configuration
    Then I delete the bucket
    Examples: Bucket lifecycle
      | tenant_user           | lifecycle_configuration_rule                                                | object_key        |
      | vcd-site_ossauto1_tu1 | {"prefix":"sample_object","status":"Enabled","storage_class":"STANDARD_IA"} | sample_object.txt |

