@common_test_suite @common @bucket_tagging
Feature: VMware OSE Common Test Suite/Validate Bucket Tagging Functionality

  Scenario Outline: Put single Bucket tagging with normal characters
    Given I am a tenant user <tenant_user>
    When I add Bucket tagging with parameters <parameters>
    Then I delete the bucket
    Examples: Bucket tagging
      | tenant_user           | parameters                                |
      | vcd-site_ossauto1_tu1 | {'TagSet':[{'Key': 'k1', 'Value': 'v1'}]} |
      | vcd-site_ossauto1_tu1 | {'TagSet':[{'Key': 'K1', 'Value': 'V1'}]} |
      | vcd-site_ossauto1_tu1 | {'TagSet':[{'Key': '1', 'Value': '1'}]}   |

  Scenario Outline: Put Single Bucket Tagging with special characters
    Given I am a tenant user <tenant_user>
    When I add Bucket tagging with parameters <parameters>
    Then I delete the bucket
    Examples: Bucket tagging
      | tenant_user           | parameters                                  |
      | vcd-site_ossauto1_tu1 | {'TagSet':[{'Key': 'k+1', 'Value': 'v+1'}]} |
      | vcd-site_ossauto1_tu1 | {'TagSet':[{'Key': 'k@1', 'Value': 'v@1'}]} |

  Scenario Outline: Put multiple Bucket tagging
    Given I am a tenant user <tenant_user>
    When I add Bucket tagging with parameters <parameters>
    Then I delete the bucket
    Examples: Bucket tagging
      | tenant_user           | parameters                                                             |
      | vcd-site_ossauto1_tu1 | {'TagSet':[{'Key': 'k1', 'Value': 'v1'},{'Key': 'K1', 'Value': 'V1'}]} |

  Scenario Outline: Get Bucket tagging
    Given I am a tenant user <tenant_user>
    When I add Bucket tagging with parameters <parameters>
    Then I get Bucket tagging
    Then I delete Bucket tagging
    Then I delete the bucket
    Examples: Bucket tagging
      | tenant_user           | parameters                                |
      | vcd-site_ossauto1_tu1 | {'TagSet':[{'Key': 'k1', 'Value': 'v1'}]} |

  Scenario Outline: Delete Bucket tagging
    Given I am a tenant user <tenant_user>
    When I add Bucket tagging with parameters <parameters>
    Then I delete Bucket tagging
    Then I delete the bucket
    Examples: Bucket tagging
      | tenant_user           | parameters                                |
      | vcd-site_ossauto1_tu1 | {'TagSet':[{'Key': 'k1', 'Value': 'v1'}]} |