@common_test_suite @common @bucket_versioning
Feature: VMware OSE Common Test Suite/Validate Bucket Versioning Functionality

  Scenario Outline: Put bucket versioning with enabled status
    Given I am a tenant user <tenant_user>
    When I created a bucket with prefix <bucket_prefix>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I update bucket's versioning status <versioning_status>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Bucket Versioning
      | tenant_user           | bucket_prefix  | expected_status_code_create_bucket | expected_status_code_delete_bucket | versioning_status |
      | vcd-site_ossauto1_tu1 | osis-api-auto- | 200                                | 204                                | Enable            |

  Scenario Outline: Put bucket versioning with suspended status
    Given I am a tenant user <tenant_user>
    When I created a bucket with prefix <bucket_prefix>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I enable bucket's versioning
    Then I disable bucket's versioning status
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Bucket Versioning
      | tenant_user           | bucket_prefix  | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | osis-api-auto- | 200                                | 204                                |

  Scenario Outline: Put bucket versioning with invalid status value
    Given I am a tenant user <tenant_user>
    When I created a bucket with prefix <bucket_prefix>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I update bucket's versioning status <versioning_status>
    Then I disable bucket's versioning status
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Bucket Versioning
      | tenant_user           | bucket_prefix  | expected_status_code_create_bucket | expected_status_code_delete_bucket | versioning_status         |
      | vcd-site_ossauto1_tu1 | osis-api-auto- | 200                                | 204                                | invalid_versioning_status |

  Scenario Outline: Put bucket versioning with matched content-md5
    Given I am a tenant user <tenant_user>
    When I created a bucket with prefix <bucket_prefix>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I put bucket's versioning <versioning_status> with matched content-MD5
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Bucket Versioning
      | tenant_user           | bucket_prefix  | expected_status_code_create_bucket | expected_status_code_delete_bucket | versioning_status |
      | vcd-site_ossauto1_tu1 | osis-api-auto- | 200                                | 204                                | Enabled           |


  Scenario Outline: Put bucket versioning with mismatched content-md5
    Given I am a tenant user <tenant_user>
    When I created a bucket with prefix <bucket_prefix>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I put bucket's versioning <invalid_status> with mismatched content-MD5
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Bucket Versioning
      | tenant_user           | bucket_prefix  | expected_status_code_create_bucket | expected_status_code_delete_bucket | invalid_status |
      | vcd-site_ossauto1_tu1 | osis-api-auto- | 200                                | 204                                | InvalidStatus  |

  @debug_bucket_versioning
  Scenario Outline: Put bucket versioning with MFA
    Given I am a tenant user <tenant_user>
    When I created a bucket with prefix <bucket_prefix>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I put bucket's versioning <versioning_status> with MFA <mfa>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Bucket Versioning
      | tenant_user           | bucket_prefix  | expected_status_code_create_bucket | expected_status_code_delete_bucket | versioning_status | mfa           |
      | vcd-site_ossauto1_tu1 | osis-api-auto- | 200                                | 204                                | Enabled           | SERIAL 123456 |