@common_test_suite @common @head_object
Feature: VMware OSE Common Test Suite/Validate Head Object Functionality


  Scenario Outline: Head object under own bucket
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should HEAD object with key <object_key> and parameters <head_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: Head object
      | tenant_user           | object_key        | parameters | head_object_parameters |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {}                     |

  Scenario Outline: Head object|IfUnmodifiedSince
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should HEAD object with key <object_key> and parameters <head_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: Head object
      | tenant_user           | object_key        | parameters | head_object_parameters                                                                                 |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"IfUnmodifiedSince": "datetime.datetime.now(tz=datetime.timezone.utc)+datetime.timedelta(days=365)" } |


  Scenario Outline: Head object|IfModifiedSince
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should HEAD object with key <object_key> and parameters <head_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: Head object
      | tenant_user           | object_key        | parameters | head_object_parameters                                                                              |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"IfModifiedSince": "datetime.datetime.now(tz=datetime.timezone.utc)+datetime.timedelta(days=-1)" } |


  Scenario Outline: Head object|Range
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should HEAD object with key <object_key> and parameters <head_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: Head object
      | tenant_user           | object_key        | parameters | head_object_parameters |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"Range": "TODO" }     |

  Scenario Outline: Head object|IfMatch
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should HEAD object with key <object_key> and parameters <head_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: Head object
      | tenant_user           | object_key        | parameters | head_object_parameters    |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"IfMatch": "{{e_tag}}" } |
  @demo_copy_object
  Scenario Outline: Head object|VersionId
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I update bucket's versioning status <versioning_status>
    Then I put object <other_object_key> to bucket
    Then I should HEAD object with key <object_key> and parameters <head_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: Head object
      | tenant_user           | object_key        | other_object_key  | parameters | head_object_parameters           | versioning_status |
      | vcd-site_ossauto1_tu1 | sample_object.txt | sample_object.txt | {}         | {"VersionId": "{{version_id}}" } | Enable            |


  Scenario Outline: Head object|PartNumber
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should HEAD object with key <object_key> and parameters <head_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: Head object
      | tenant_user           | object_key        | parameters | head_object_parameters |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"PartNumber": 123 }   |


  Scenario Outline: Head object|RequestPayer
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should HEAD object with key <object_key> and parameters <head_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: Head object
      | tenant_user           | object_key        | parameters | head_object_parameters    |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"RequestPayer": "Test" } |


  Scenario Outline: Head object|Key
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should HEAD object with key <object_key> and parameters <head_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: Head object
      | tenant_user           | object_key        | parameters | head_object_parameters        |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"Key": "sample_object.txt" } |


  Scenario Outline: Head object|Path object
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should HEAD object with key <object_key> and parameters <head_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    Then I delete the bucket
    Examples: Upload object
      | tenant_user           | object_key       | parameters                                   | head_object_parameters       |
      | vcd-site_ossauto1_tu1 | folder/subfolder | {"ContentType" : "text/plain;charset=utf-8"} | {"Key": "folder/subfolder" } |