@common_test_suite @common @list_objects
Feature: VMware OSE Common Test Suite/Validate List Object Functionality

  @debug_list_objects
  Scenario Outline: List objects |Bucket
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List objects with parameters <list_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | parameters | list_object_parameters |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {}                     |

  Scenario Outline: List objects |MaxKeys
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List objects with parameters <list_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | parameters | list_object_parameters |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"MaxKeys":1}          |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"MaxKeys":1000}       |

  Scenario Outline: List objects |MaxKeys
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should fail to list objects with parameters <list_object_parameters> with negative value
    Then I verify that expected error <expected_error> is found
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | parameters | list_object_parameters | expected_error                                               |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"MaxKeys":-1}         | Parameter max-keys could not be assigned to a negative value |

  Scenario Outline: List objects|Prefix
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List objects with parameters <list_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | parameters | list_object_parameters         |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"Prefix":"sample_object.txt"} |

  Scenario Outline: List objects v2|Delimiter
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List objects with parameters <list_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    Then I delete the bucket
    Examples: List objects
      | tenant_user           | object_key | parameters        | list_object_parameters |
      | vcd-site_ossauto1_tu1 | folder/    | {"Body" : "test"} | {"Delimiter":"/"}      |

  Scenario Outline: List objects v2|Delimiter and Prefix
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List objects with parameters <list_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    Then I delete the bucket
    Examples: List objects
      | tenant_user           | object_key | parameters        | list_object_parameters              |
      | vcd-site_ossauto1_tu1 | folder/    | {"Body" : "test"} | {"Delimiter":"/","Prefix":"folder"} |

  Scenario Outline: List objects v2|Prefix
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List objects with parameters <list_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | parameters                      | list_object_parameters          |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {"RequestPayer":"requsetpayer"} | {"RequestPayer":"requsetpayer"} |

  Scenario Outline: List objects |path object
    Given I am a tenant user <tenant_user>
    When I upload Path object to bucket with key <object_key> and parameters <parameters>
    Then I put Path object <path_object_key> to bucket
    Then I should List objects with parameters <list_object_parameters> successfully
    Then I delete object with key <object_key> from bucket
    Then I delete object with key <path_object_key> from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key | path_object_key | parameters | list_object_parameters |
      | vcd-site_ossauto1_tu1 | sub1/      | sub2/           | {}         | {}                     |
