@common_test_suite @common @list_object_v2
Feature: VMware OSE Common Test Suite/Validate List Object V2 Functionality

  Scenario Outline: List objects v2|Bucket
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List object V2 with parameters <list_object_v2_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List object V2
      | tenant_user           | object_key        | parameters | list_object_v2_parameters |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {}                        |


  Scenario Outline: List objects v2|MaxKeys
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List object V2 with parameters <list_object_v2_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List object V2
      | tenant_user           | object_key        | parameters | list_object_v2_parameters |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"MaxKeys":1}             |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"MaxKeys":1000}          |


  Scenario Outline: List objects v2|MaxKeys
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should fail to list object V2 with parameters <list_object_v2_parameters> with negative value
    Then I verify that expected error <expected_error> is found
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List object V2
      | tenant_user           | object_key        | parameters | list_object_v2_parameters | expected_error                                               |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"MaxKeys":-1}            | Parameter max-keys could not be assigned to a negative value |


  Scenario Outline: List objects v2|Prefix
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List object V2 with parameters <list_object_v2_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List object V2
      | tenant_user           | object_key        | parameters | list_object_v2_parameters      |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"Prefix":"sample_object.txt"} |

  Scenario Outline: List objects v2|Delimiter
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List object V2 with parameters <list_object_v2_parameters> successfully
    Then I delete object with key <object_key> from bucket
    Then I delete the bucket
    Examples: Upload object
      | tenant_user           | object_key | parameters        | list_object_v2_parameters |
      | vcd-site_ossauto1_tu1 | folder/    | {"Body" : "test"} | {"Delimiter":"/"}         |


  Scenario Outline: List objects v2|Delimiter and Prefix
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List object V2 with parameters <list_object_v2_parameters> successfully
    Then I delete object with key <object_key> from bucket
    Then I delete the bucket
    Examples: Upload object
      | tenant_user           | object_key | parameters        | list_object_v2_parameters           |
      | vcd-site_ossauto1_tu1 | folder/    | {"Body" : "test"} | {"Delimiter":"/","Prefix":"folder"} |

  Scenario Outline: List objects v2|FetchOwner
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List object V2 with parameters <list_object_v2_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List object V2
      | tenant_user           | object_key        | parameters | list_object_v2_parameters |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"FetchOwner":False}      |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"FetchOwner":True}       |


  Scenario Outline: List objects v2|Prefix
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List object V2 with parameters <list_object_v2_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List object V2
      | tenant_user           | object_key        | parameters                      | list_object_v2_parameters       |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {"RequestPayer":"requsetpayer"} | {"RequestPayer":"requsetpayer"} |

  Scenario Outline: List objects v2|StartAfter
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List object V2 with parameters <list_object_v2_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List object V2
      | tenant_user           | object_key        | parameters | list_object_v2_parameters          |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"StartAfter":"sample_object.txt"} |


  Scenario Outline: List multiple objects v2|StartAfter
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I put object <other_object_key> to bucket
    Then I should List object V2 with parameters <list_object_v2_parameters> successfully
    Then I delete object with key <object_key> from bucket
    Then I delete object with key <other_object_key> from bucket
    And I delete the bucket
    Examples: List object V2
      | tenant_user           | object_key        | other_object_key    | parameters | list_object_v2_parameters            |
      | vcd-site_ossauto1_tu1 | sample_object.txt | sample_object_1.txt | {}         | {"StartAfter":"sample_object_1.txt"} |

#  Scenario Outline: List objects v2|Accept
#    Given I am a tenant user <tenant_user>
#    When I upload object to bucket with key <object_key> and parameters <parameters>
#    Then I should List object V2 with parameters <list_object_v2_parameters> successfully
#    Then I delete object with key <object_key> from bucket
#    And I delete the bucket
#    Examples: List object V2
#      | tenant_user           | object_key        | parameters | list_object_v2_parameters      |
#      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"Accept": "application/json"} |


  Scenario Outline: List objects v2|ContinuationToken
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then I should List object V2 with parameters <list_object_v2_parameters> successfully
    Then I delete object with key <object_key> from bucket
    And I delete the bucket
    Examples: List object V2
      | tenant_user           | object_key        | parameters | list_object_v2_parameters     |
      | vcd-site_ossauto1_tu1 | sample_object.txt | {}         | {"ContinuationToken": "TODO"} |

  @debug_list_object_v2
  Scenario Outline: List objects v2|path object
    Given I am a tenant user <tenant_user>
    When I upload Path object to bucket with key <object_key> and parameters <parameters>
    Then I put Path object <path_object_key> to bucket
    Then I should List object V2 with parameters <list_object_v2_parameters> successfully
#    Then I delete object with key <object_key> from bucket
#    Then I delete object with key <other_object_key> from bucket
#    And I delete the bucket
    Examples: List object V2
      | tenant_user           | object_key | path_object_key | parameters | list_object_v2_parameters |
      | vcd-site_ossauto1_tu1 | sub1/      | sub2/            | {}         | {}                        |
