@common_test_suite @common @list_object_versions
Feature: VMware OSE Common Test Suite/Validate List Object Versions Functionality

  Scenario Outline: List object versions
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then  I update bucket's versioning status <versioning_status>
    Then I put object <other_object_key> to bucket
    Then I should List object versions with parameters <list_object_versions_parameters> successfully
    Then I delete object with versions from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | other_object_key  | parameters | list_object_versions_parameters | versioning_status |
      | vcd-site_ossauto1_tu1 | sample_object.txt | sample_object.txt | {}         | {}                              | Enable            |

  Scenario Outline: List object versions|KeyMarker
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then  I update bucket's versioning status <versioning_status>
    Then I put object <other_object_key> to bucket
    Then I should List object versions with parameters <list_object_versions_parameters> successfully
    Then I delete object with versions from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | other_object_key  | parameters | list_object_versions_parameters | versioning_status |
      | vcd-site_ossauto1_tu1 | sample_object.txt | sample_object.txt | {}         | {"KeyMarker":"sample_object"}   | Enable            |

  Scenario Outline: List object versions|MaxKeys
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then  I update bucket's versioning status <versioning_status>
    Then I put object <other_object_key> to bucket
    Then I should List object versions with parameters <list_object_versions_parameters> successfully
    Then I delete object with versions from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | other_object_key  | parameters | list_object_versions_parameters | versioning_status |
      | vcd-site_ossauto1_tu1 | sample_object.txt | sample_object.txt | {}         | {"MaxKeys":1}                   | Enable            |
      | vcd-site_ossauto1_tu1 | sample_object.txt | sample_object.txt | {}         | {"MaxKeys":1000}                | Enable            |

  Scenario Outline: List object versions|MaxKeys with negative value
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then  I update bucket's versioning status <versioning_status>
    Then I put object <other_object_key> to bucket
    Then I should fail to list object versions with parameters <list_object_versions_parameters> with negative value
    Then I verify that expected error <expected_error> is found
    Then I delete object with versions from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | other_object_key  | parameters | list_object_versions_parameters | versioning_status | expected_error                                                |
      | vcd-site_ossauto1_tu1 | sample_object.txt | sample_object.txt | {}         | {"MaxKeys":-1}                  | Enable            | Parameter max-keys could not be assigned to a negative value. |

  Scenario Outline: List object versions|Prefix
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then  I update bucket's versioning status <versioning_status>
    Then I put object <other_object_key> to bucket
    Then I should List object versions with parameters <list_object_versions_parameters> successfully
    Then I delete object with versions from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | other_object_key  | parameters | list_object_versions_parameters | versioning_status |
      | vcd-site_ossauto1_tu1 | sample_object.txt | sample_object.txt | {}         | {"Prefix":"sample_object.txt"}  | Enable            |

  Scenario Outline: List object versions|multiple versions and include both file and folder
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then  I update bucket's versioning status <versioning_status>
    Then I put object <other_object_key> to bucket
    Then I put Path object <path_object_key> to bucket
    Then I should List object versions with parameters <list_object_versions_parameters> successfully
    Then I delete object with versions from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | other_object_key                                                            | parameters | list_object_versions_parameters | versioning_status | path_object_key    |
      | vcd-site_ossauto1_tu1 | sample_object.txt | sample_object.txt#sample_object_1.txt#sample_object.txt#sample_object_1.txt | {}         | {"Prefix":"sample_object.txt"}  | Enable            | folder1/subfolder1 |

  Scenario Outline: List object versions|EncodingType
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then  I update bucket's versioning status <versioning_status>
    Then I put object <other_object_key> to bucket
    Then I should List object versions with parameters <list_object_versions_parameters> successfully
    Then I delete object with versions from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | other_object_key  | parameters | list_object_versions_parameters | versioning_status |
      | vcd-site_ossauto1_tu1 | sample_object.txt | sample_object.txt | {}         | {"EncodingType":"TODO"}         | Enable            |

#  @te_cloudian
#  Scenario Outline: List object versions|VersionIdMarker
#    Given I am a tenant user <tenant_user>
#    When I upload object to bucket with key <object_key> and parameters <parameters>
#    Then  I update bucket's versioning status <versioning_status>
#    Then I put object <other_object_key> to bucket
#    Then I should List object versions with parameters <list_object_versions_parameters> successfully
#    Then I delete object with versions from bucket
#    And I delete the bucket
#    Examples: List objects
#      | tenant_user           | object_key        | other_object_key  | parameters | list_object_versions_parameters      | versioning_status |
#      | vcd-site_ossauto1_tu1 | sample_object.txt | sample_object.txt | {}         | {"VersionIdMarker":"{{version_id}}"} | Enable            |


  Scenario Outline: List object versions|VersionIdMarker and KeyMarker
    Given I am a tenant user <tenant_user>
    When I upload object to bucket with key <object_key> and parameters <parameters>
    Then  I update bucket's versioning status <versioning_status>
    Then I put object <other_object_key> to bucket
    Then I should List object versions with parameters <list_object_versions_parameters> successfully
    Then I delete object with versions from bucket
    And I delete the bucket
    Examples: List objects
      | tenant_user           | object_key        | other_object_key  | parameters | list_object_versions_parameters                                  | versioning_status |
      | vcd-site_ossauto1_tu1 | sample_object.txt | sample_object.txt | {}         | {"VersionIdMarker":"{{version_id}}","KeyMarker":"sample_object"} | Enable            |