@common_test_suite @common @object_acl
Feature: VMware OSE Common Test Suite/Validate Object ACL Functionality

  @debug-test
  Scenario Outline: Add Object ACL|AccessControlPolicy to same tenant's user with FULL control
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Object Acl|AccessControlPolicy to tenant user:<owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>,<object_key>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get Object ACL:<object_key>
    Given I am the other tenant user <other_tenant_user>
    Then I get Object ACL:<object_key>
    Given I am a tenant user <tenant_user>
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Object ACL
      | tenant_user           | object_key        | other_tenant_user     | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu2 | CanonicalUser | FULL_CONTROL       | 200                                | 204                                |

  Scenario Outline: Add Object ACL|AccessControlPolicy to same tenant's user with READ permission
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Object Acl|AccessControlPolicy to tenant user:<owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>,<object_key>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Object ACL
      | tenant_user           | object_key        | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu2 | CanonicalUser | READ               | 200                                | 204                                |

  Scenario Outline: Add Object ACL|AccessControlPolicy to same tenant's user with WRITE permission
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Object Acl|AccessControlPolicy to tenant user:<owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>,<object_key>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get Object ACL:<object_key>
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Object ACL
      | tenant_user           | object_key        | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu2 | CanonicalUser | WRITE              | 200                                | 204                                |

  Scenario Outline: Add Object ACL|AccessControlPolicy to same tenant's user with WRITE_ACP permission
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Object Acl|AccessControlPolicy to tenant user:<owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>,<object_key>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get Object ACL:<object_key>
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Object ACL
      | tenant_user           | object_key        | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu2 | CanonicalUser | WRITE_ACP          | 200                                | 204                                |

#  @debug-fail
  Scenario Outline: Add Object ACL|AccessControlPolicy to same tenant's user with READ_ACP permission
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Object Acl|AccessControlPolicy to tenant user:<owner_display_name>,<owner_id>,<grantee_display_name>,<grantee_id>,<grantee_type>,<grantee_permission>,<object_key>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get Object ACL:<object_key>
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Object ACL
      | tenant_user           | object_key        | owner_display_name    | owner_id              | grantee_display_name  | grantee_id            | grantee_type  | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | vcd-site_ossauto1_tu2 | CanonicalUser | READ_ACP           | 200                                | 204                                |

  Scenario Outline: Add Object ACL to All users
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Object ACL to All Users:<uri>, <owner_id>,<grantee_id>,<grantee_type>,<grantee_permission>,<object_key>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get Object ACL:<object_key>
    Given I am the other tenant user <other_tenant_user>
    Then I get Object ACL:<object_key>
#    Then I list all objects
    Given I am a tenant user <tenant_user>
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Create bucket with prefix
      | tenant_user           | object_key        | other_tenant_user     | uri                                             | owner_id              | grantee_id            | grantee_type | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu2 | http://acs.amazonaws.com/groups/global/AllUsers | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | Group        | FULL_CONTROL       | 200                                | 204                                |

  Scenario Outline: Add Object ACL to All users
    Given I am a tenant user <tenant_user>
    Then I upload object with key <object_key>
    Then I list all objects
    When I Put Object ACL to Authenticated Users:<uri>, <owner_id>,<grantee_id>,<grantee_type>,<grantee_permission>,<object_key>
    Then I verify create bucket status <expected_status_code_create_bucket>
    Then I get Object ACL:<object_key>
    Given I am the other tenant user <other_tenant_user>
    Then I get Object ACL:<object_key>
#    Then I list all objects
    Given I am a tenant user <tenant_user>
    Then I delete the object with key <object_key>
    Then I delete the bucket
    Then I verify delete bucket status <expected_status_code_delete_bucket>
    Examples: Create bucket with prefix
      | tenant_user           | object_key        | other_tenant_user     | uri                                                       | owner_id              | grantee_id            | grantee_type | grantee_permission | expected_status_code_create_bucket | expected_status_code_delete_bucket |
      | vcd-site_ossauto1_tu1 | sample_object.txt | vcd-site_ossauto1_tu2 | http://acs.amazonaws.com/groups/global/AuthenticatedUsers | vcd-site_ossauto1_tu1 | vcd-site_ossauto1_tu2 | Group        | FULL_CONTROL       | 200                                | 204                                |


