@common_test_suite @common @create_multipart_upload
Feature: VMware OSE Common Test Suite/Validate Create Multipart Upload functionality with Folder object

  Scenario Outline: Verify Create multipart upload to folder/object
    Given I am a tenant user <tenant_user>
    When I upload Path object to bucket with key <object_key> and parameters <parameters>
    Then I put Path object <path_object_key> to bucket
    When I should create multipart upload successfully with <create_multipart_upload_parameters>
    Then I delete object with key <object_key> from bucket
    Then I delete object with key <path_object_key> from bucket
    Then I delete the bucket
    Examples: multipart upload
      | tenant_user           | object_key         | path_object_key         | parameters | create_multipart_upload_parameters                                                                                                                                    |
      | vcd-site_ossauto1_tu1 | sub1/viva_test.bmp | sub1/sub2/viva_test.bmp | {}         | {"Key":"sub1/viva_test.bmp","StorageClass":"STANDARD"}                                                                                                                |
      | vcd-site_ossauto1_tu1 | sub1/viva_test.bmp | sub1/sub2/viva_test.bmp | {}         | {"Key":"sub1/sub2/viva_test.bmp","StorageClass":"STANDARD"}                                                                                                           |
      | vcd-site_ossauto1_tu1 | sub1/viva_test.bmp | sub1/sub2/viva_test.bmp | {}         | {"Key":"sub1/viva_test.bmp","ContentType":"text/plain"}                                                                                                               |
      | vcd-site_ossauto1_tu1 | sub1/viva_test.bmp | sub1/sub2/viva_test.bmp | {}         | {"Key":"sub1/viva_test.bmp","Tagging": "k1=v1"}                                                                                                                       |
      | vcd-site_ossauto1_tu1 | sub1/viva_test.bmp | sub1/sub2/viva_test.bmp | {}         | {"Key":"sub1/viva_test.bmp","Metadata": {"k1":"v1"}}                                                                                                                  |
      | vcd-site_ossauto1_tu1 | sub1/viva_test.bmp | sub1/sub2/viva_test.bmp | {}         | {"Key":"sub1/viva_test.bmp","Expires":"datetime.datetime.now(tz=datetime.timezone.utc)+datetime.timedelta(days=1)"}                                                   |
      | vcd-site_ossauto1_tu1 | sub1/viva_test.bmp | sub1/sub2/viva_test.bmp | {}         | {"Key":"sub1/viva_test.bmp","ContentDisposition":"inline"}                                                                                                            |
      | vcd-site_ossauto1_tu1 | sub1/viva_test.bmp | sub1/sub2/viva_test.bmp | {}         | {"Key":"sub1/viva_test.bmp","ContentLanguage":"en-US"}                                                                                                                |
      | vcd-site_ossauto1_tu1 | sub1/viva_test.bmp | sub1/sub2/viva_test.bmp | {}         | {"Key":"sub1/viva_test.bmp","ContentEncoding":"gzip"}                                                                                                                 |
      | vcd-site_ossauto1_tu1 | sub1/viva_test.bmp | sub1/sub2/viva_test.bmp | {}         | {"Key":"sub1/viva_test.bmp","CacheControl":"CacheControl"}                                                                                                            |
      | vcd-site_ossauto1_tu1 | sub1/viva_test.bmp | sub1/sub2/viva_test.bmp | {}         | {"Key":"sub1/viva_test.bmp","RequestPayer":"RequestPayer"}                                                                                                            |