import os

from common_libraries.boto3_client import Boto3Client
from common_libraries.data_providers.file_utils import FileUtils


class OSISTestBase:
    http_client = None
    file_utils = None
    boto3_client = None
    boto3_resource = None

    def __init__(self):
        self.boto3_client = Boto3Client(connect_type="client")
        self.boto3_resource = Boto3Client(connect_type="resource").get_boto3_resource()
        self.file_utils = FileUtils()

    @staticmethod
    def data_preparation():
        test_environment_yaml = os.environ["test_environment_yaml"]
        FileUtils.update_data_in_yaml_file(
            test_environment_yaml, tenant_name="ossauto1", tenant_user="tu3", parameter_name="access_key",
            parameter_value="access_key_test")
        FileUtils.update_data_in_yaml_file(
            test_environment_yaml, tenant_name="ossauto1", tenant_user="tu3", parameter_name="secret_key",
            parameter_value="secret_key_test")
