import urllib

from behave import *

from common_libraries.data_generator import DataGenerator
from common_libraries.decorator import Decorator
from common_libraries.logger import TestLog


@Decorator.log(my_logger=TestLog())
@Decorator.exception_handler()
@When("I add Bucket Request Payment with parameters {parameters}")
def step_impl(context, parameters):
    """
    Add Bucket Request Payment
    :param context:
    :param parameters:
    :return:
    """
    # response = bucket_request_payment.put(
    #     ChecksumAlgorithm='CRC32' | 'CRC32C' | 'SHA1' | 'SHA256',
    #     RequestPaymentConfiguration={
    #         'Payer': 'Requester' | 'BucketOwner'
    #     },
    #     ExpectedBucketOwner='string'
    # )
    logger = context.logger
    # parse arguments
    bucket_request_payment_configuration = eval(parameters)
    bucket_name = DataGenerator.generate_bucket_name(context)
    try:

        context.boto3_client.s3_resource_create_bucket(bucket_name=bucket_name)
        bucket_request_payment = context.s3_resource.BucketRequestPayment(bucket_name)
        put_bucket_request_payment = bucket_request_payment.put(
            RequestPaymentConfiguration=bucket_request_payment_configuration
        )
        http_status_code = put_bucket_request_payment["ResponseMetadata"]["HTTPStatusCode"]
        expected_status_code = "200"
        assert int(
            http_status_code) == int(
            expected_status_code), f"The excepted status code '" + expected_status_code + "'  but the actual status code '" + str(
            http_status_code) + "'"
        log_message = "Put BucketRequestPayment: " + str(
            str(put_bucket_request_payment))
        context.logger.debug(log_message)
        TestLog.attach_allure_log(
            log_message=log_message,
            log_type=TestLog.LOG_TYPE_TEST_EXECUTION)
    except Exception as ex:
        log_error = f"Fail to add BucketRequestPayment <" + bucket_name + "> \n and get the unexpected exception: " + str(
            ex)
        logger.error(log_error)
        TestLog.attach_allure_log(
            log_message=log_error,
            log_type=TestLog.LOG_TYPE_TEST_EXCEPTION)
        raise Exception(log_error)


@Decorator.log(my_logger=TestLog())
@Decorator.exception_handler()
@Then("I get Bucket Request Payment")
def step_impl(context):
    """
    Get Bucket Request Payment
    :param context:
    :return:
    """
    logger = context.logger
    bucket_name = context.bucket_name
    try:
        get_bkt_website_response = context.s3_client.get_bucket_request_payment(
            Bucket=bucket_name
        )
        http_status_code = get_bkt_website_response["ResponseMetadata"]["HTTPStatusCode"]
        expected_status_code = "200"
        assert int(
            http_status_code) == int(
            expected_status_code), f"The excepted status code '" + expected_status_code + "'  but the actual status code '" + str(
            http_status_code) + "'"
        if get_bkt_website_response:
            log_message = "Get BucketRequestPayment: " + str(
                str(get_bkt_website_response))
            context.logger.debug(log_message)
            TestLog.attach_allure_log(
                log_message=log_message,
                log_type=TestLog.LOG_TYPE_TEST_EXECUTION)
    except Exception as ex:
        log_error = f"Fail to get BucketRequestPayment <" + bucket_name + "> \n and get the unexpected exception: " + str(
            ex)
        logger.error(log_error)
        TestLog.attach_allure_log(
            log_message=log_error,
            log_type=TestLog.LOG_TYPE_TEST_EXCEPTION)
        raise Exception(log_error)