from common_libraries.data_generator import DataGenerator


class BucketCorsTemplate:
    @staticmethod
    def get_bucket_cors_template(template_name):

        BUCKET_CORS_GET_TEMPLATE = {"CORSRules": [
            {"AllowedOrigins": ["*"], "AllowedMethods": ["GET"], "MaxAgeSeconds": 3600, "ExposeHeaders": [],
             "AllowedHeaders": ["*"]}]}

        BUCKET_CORS_POST_TEMPLATE = {"CORSRules": [
            {"AllowedOrigins": ["*"], "AllowedMethods": ["POST"], "MaxAgeSeconds": 3600, "ExposeHeaders": [],
             "AllowedHeaders": ["*"]}]}

        BUCKET_CORS_HEAD_TEMPLATE = {"CORSRules": [
            {"AllowedOrigins": ["*"], "AllowedMethods": ["GET"], "MaxAgeSeconds": 3600, "ExposeHeaders": [],
             "AllowedHeaders": ["*"]}]}

        BUCKET_CORS_PUT_TEMPLATE = {"CORSRules": [
            {"AllowedOrigins": ["*"], "AllowedMethods": ["POST"], "MaxAgeSeconds": 3600, "ExposeHeaders": [],
             "AllowedHeaders": ["*"]}]}

        BUCKET_CORS_DELETE_TEMPLATE = {"CORSRules": [
            {"AllowedOrigins": ["*"], "AllowedMethods": ["POST"], "MaxAgeSeconds": 3600, "ExposeHeaders": [],
             "AllowedHeaders": ["*"]}]}

        if template_name.lower() == str("BUCKET_CORS_GET_TEMPLATE").lower():

            return BUCKET_CORS_GET_TEMPLATE
        elif template_name.lower() == str("BUCKET_CORS_POST_TEMPLATE").lower():

            return BUCKET_CORS_POST_TEMPLATE
        elif template_name.lower() == str("BUCKET_CORS_HEAD_TEMPLATE").lower():
            return BUCKET_CORS_HEAD_TEMPLATE
        elif template_name.lower() == str("BUCKET_CORS_PUT_TEMPLATE").lower():
            return BUCKET_CORS_PUT_TEMPLATE
        elif template_name.lower() == str("BUCKET_CORS_DELETE_TEMPLATE").lower():
            return BUCKET_CORS_DELETE_TEMPLATE
        elif template_name.lower() == str("BUCKET_CONTENT_MD5_TEMPLATE").lower():
            content_md5 = '<CORSConfiguration xmlns="http://s3.amazonaws.com/doc/2006-03-01/ "><CORSRule><AllowedMethod>PUT</AllowedMethod><AllowedMethod>POST</AllowedMethod><AllowedMethod>DELETE</AllowedMethod><AllowedHeader>Content-Type</AllowedHeader><AllowedOrigin>http://s3.test.com</AllowedOrigin><ExposeHeader>x-amz-server-side-encryption</ExposeHeader><MaxAgeSeconds>0</MaxAgeSeconds></CORSRule><CORSRule><AllowedMethod>GET</AllowedMethod><AllowedHeader>*</AllowedHeader><AllowedOrigin>*</AllowedOrigin><MaxAgeSeconds>3600</MaxAgeSeconds></CORSRule></CORSConfiguration>'
            BUCKET_CONTENT_MD5_TEMPLATE = {"CORSRules": [
                {"AllowedOrigins": ["*"], "AllowedMethods": ["POST"], "MaxAgeSeconds": 3600, "ExposeHeaders": [],
                 "AllowedHeaders": ["*"]}], "ContentMD5": DataGenerator().calculate_content_md5(content_md5)}
            return
        else:
            context.logger.debug("No Bucket CORS template found!")
