from datetime import datetime

from common_libraries.data_generator import DataGenerator


class BucketLifecycleTemplate:

    @staticmethod
    def get_bucket_lifecycle_with_prefix(**kwargs):
        """
        generated data for bucket lifecycle
        :param kwargs:
        :return:
        """
        lifecycle_id = DataGenerator().id_generator_lowercase(10)
        days = 1
        status = 'Enabled'
        prefix = ''
        storage_class = 'StorageClass'
        non_current_days = 1
        expired_object_delete_marker = False
        for key, value in kwargs.items():
            if key == 'id':
                lifecycle_id = lifecycle_id
            if key == 'days':
                days = value
            if key == 'status':
                status = value
            if key == 'storage_class':
                storage_class = value
            if key == 'prefix':
                prefix = value
            if key == 'non_current_days':
                non_current_days = value
            if key == 'expired_object_delete_marker':
                expired_object_delete_marker = value
        LifecycleConfiguration = {
            'Rules': [
                {
                    'Expiration': {
                        'Days': days,
                        'ExpiredObjectDeleteMarker': expired_object_delete_marker
                    },
                    'ID': lifecycle_id,
                    'Prefix': prefix,
                    'Status': status,
                    # 'Transition': {
                    #     'Days': non_current_days,
                    #     'StorageClass': storage_class
                    # },
                    # 'NoncurrentVersionTransition': {
                    #     'NoncurrentDays': non_current_days,
                    #     'StorageClass': 'storage_class'
                    # },
                    # 'NoncurrentVersionExpiration': {
                    #     'NoncurrentDays': non_current_days
                    # },
                    'AbortIncompleteMultipartUpload': {
                        'DaysAfterInitiation': non_current_days
                    }
                },
            ]
        }

        return LifecycleConfiguration

    @staticmethod
    def get_bucket_lifecycle_with_filter(**kwargs):
        """
        generated data for bucket lifecycle
        :param kwargs:
        :return:
        """
        lifecycle_id = DataGenerator().id_generator_lowercase(10)
        days = 1
        status = 'Enabled'
        prefix = ''
        storage_class = 'StorageClass'
        non_current_days = 1
        expired_object_delete_marker = False
        for key, value in kwargs.items():
            if key == 'id':
                lifecycle_id = lifecycle_id
            if key == 'days':
                days = value
            if key == 'status':
                status = value
            if key == 'storage_class':
                storage_class = value
            if key == 'prefix':
                prefix = value
            if key == 'non_current_days':
                non_current_days = value
            if key == 'expired_object_delete_marker':
                expired_object_delete_marker = value
        LifecycleConfiguration = {
            'Rules': [
                {
                    'Expiration': {
                        'Days': days,
                        'ExpiredObjectDeleteMarker': expired_object_delete_marker
                    },
                    'ID': lifecycle_id,
                    'Prefix': prefix,
                    'Status': status,
                    # 'Transition': {
                    #     'Days': non_current_days,
                    #     'StorageClass': storage_class
                    # },
                    # 'NoncurrentVersionTransition': {
                    #     'NoncurrentDays': non_current_days,
                    #     'StorageClass': 'storage_class'
                    # },
                    # 'NoncurrentVersionExpiration': {
                    #     'NoncurrentDays': non_current_days
                    # },
                    'AbortIncompleteMultipartUpload': {
                        'DaysAfterInitiation': non_current_days
                    }
                },
            ]
        }

        return LifecycleConfiguration

    @staticmethod
    def get_bucket_lifecycle_configuration_with_filter(**kwargs):
        """
        generated data for bucket lifecycle configuration with filter
        :param kwargs:
        :return:
        """
        id = DataGenerator().id_generator_lowercase(10)
        days = 1
        status = 'Enabled'
        prefix = ''
        storage_class = 'GLACIER'
        non_current_days = 1
        expired_object_delete_marker = False
        for key, value in kwargs.items():
            if key == 'id':
                id = id
            if key == 'days':
                days = value
            if key == 'status':
                status = value
            if key == 'storage_class':
                storage_class = value
            if key == 'prefix':
                prefix = value
            if key == 'non_current_days':
                non_current_days = value
            if key == 'expired_object_delete_marker':
                expired_object_delete_marker = value
        LifecycleConfiguration = {
            'Rules': [
                {
                    'Expiration': {
                        'Days': days,
                        'ExpiredObjectDeleteMarker': expired_object_delete_marker
                    },
                    'ID': id,
                    'Status': status,
                    'Filter': {
                        'Prefix': prefix
                    },
                    # 'Transitions': [{
                    #     'Days': non_current_days,
                    #     'StorageClass': storage_class
                    # }],
                    # 'NoncurrentVersionTransitions': [{
                    #     'NoncurrentDays': non_current_days,
                    #     'StorageClass': 'storage_class'
                    # }],
                    # 'NoncurrentVersionExpiration': {
                    #     'NoncurrentDays': non_current_days
                    # },
                    'AbortIncompleteMultipartUpload': {
                        'DaysAfterInitiation': non_current_days
                    }
                }
            ]
        }

        return LifecycleConfiguration

    @staticmethod
    def get_bucket_lifecycle_configuration_with_prefix(**kwargs):
        """
        generated data for bucket lifecycle configuration with prefix
        :param kwargs:
        :return:
        """
        lifecycle_id = DataGenerator().id_generator_lowercase(10)
        days = 1
        status = 'Enabled'
        prefix = ''
        storage_class = 'GLACIER'
        non_current_days = 1
        expired_object_delete_marker = False
        for key, value in kwargs.items():
            if key == 'lifecycle_id':
                lifecycle_id = lifecycle_id
            if key == 'days':
                days = value
            if key == 'status':
                status = value
            if key == 'storage_class':
                storage_class = value
            if key == 'prefix':
                prefix = value
            if key == 'non_current_days':
                non_current_days = value
            if key == 'expired_object_delete_marker':
                expired_object_delete_marker = value
        LifecycleConfiguration = {
            'Rules': [
                {
                    'Expiration': {
                        'Days': days,
                        'ExpiredObjectDeleteMarker': expired_object_delete_marker
                    },
                    'ID': lifecycle_id,
                    'Status': status,
                    'Prefix': prefix,
                    # 'Transitions': [{
                    #     'Days': non_current_days,
                    #     'StorageClass': storage_class
                    # }],
                    # 'NoncurrentVersionTransitions': [{
                    #     'NoncurrentDays': non_current_days,
                    #     'StorageClass': 'storage_class'
                    # }],
                    'NoncurrentVersionExpiration': {
                        'NoncurrentDays': non_current_days
                    },
                    'AbortIncompleteMultipartUpload': {
                        'DaysAfterInitiation': non_current_days
                    }
                },
            ]
        }

        return LifecycleConfiguration

    @staticmethod
    def get_bucket_lifecycle_for_all_object(**kwargs):
        """
        :param kwargs:
        :return:
        """
        id = DataGenerator().id_generator_lowercase(10)
        days = 1
        status = 'Enabled'
        storage_class = 'GLACIER'
        non_current_days = 1
        days_after_initiation = 1
        expired_object_delete_marker = False
        for key, value in kwargs.items():
            if key == 'id':
                id = id
            if key == 'days':
                days = value
            if key == 'status':
                status = value
            if key == 'storage_class':
                storage_class = value
            if key == 'non_current_days':
                non_current_days = value
            if key == 'expired_object_delete_marker':
                expired_object_delete_marker = value
        LifecycleConfiguration = {
            "Rules": [
                {
                    'Expiration': {
                        'Days': days,
                        'ExpiredObjectDeleteMarker': expired_object_delete_marker
                    },
                    'ID': id,
                    'Status': status,
                    # 'Transition': {
                    #     'Days': non_current_days,
                    #     'StorageClass': storage_class
                    # },
                    # 'NoncurrentVersionTransition': {
                    #     'NoncurrentDays': non_current_days,
                    #     'StorageClass': storage_class
                    # },
                    'NoncurrentVersionExpiration': {
                        'NoncurrentDays': non_current_days
                    },
                    'AbortIncompleteMultipartUpload': {
                        'DaysAfterInitiation': days_after_initiation
                    }
                }
            ]
        }
        return LifecycleConfiguration
