class BucketPolicyTemplate:
    @staticmethod
    def get_bucket_policy(template_name):

        BUCKET_POLICY_TEMPLATE_1 = {
            'Version': '2012-10-17',
            'Statement': [{
                'Sid': '',
                'Effect': 'Allow',
                'Principal': '*',
                'Action': ['s3:*'],
                'Resource': 'arn:aws:s3:::{{bucket_name}}/*'
            }]
        }

        BUCKET_POLICY_TEMPLATE_WORLD_READ_WRITE = {
            'Version': '2012-10-17',
            'Statement': [{
                'Sid': 'WorldReadWrite',
                'Effect': 'Allow',
                'Principal': '*',
                'Action': ['s3:*'],
                'Resource': 'arn:aws:s3:::{{bucket_name}}/*'
            }]
        }

        BUCKET_POLICY_TEMPLATE_WORLD_WRITE = {
            'Version': '2012-10-17',
            'Statement': [{
                'Sid': 'WorldWrite',
                'Effect': 'Allow',
                'Principal': '*',
                'Action': ['s3:*'],
                'Resource': 'arn:aws:s3:::{{bucket_name}}/*'
            }]
        }

        if template_name.lower() == str("BUCKET_POLICY_TEMPLATE_1").lower():
            return BUCKET_POLICY_TEMPLATE_1
        elif template_name.lower() == str("BUCKET_POLICY_TEMPLATE_WORLD_READ_WRITE").lower():
            return BUCKET_POLICY_TEMPLATE_WORLD_READ_WRITE
        elif template_name.lower() == str("BUCKET_POLICY_TEMPLATE_WORLD_WRITE").lower():
            return BUCKET_POLICY_TEMPLATE_WORLD_WRITE
