class BucketAclTemplate:
    # granted_permission: FULL_CONTROL,READ,WRITE,READ_ACP,WRITE_ACP
    ACL_FULL_CONTROL = '{"grants": [{"grantee": {"id": "{{X-VMWARE-VOSE-USER-CONTEXT}}"},"permission": "FULL_CONTROL"},{"grantee": {"uri": "http://acs.amazonaws.com/groups/global/AuthenticatedUsers"},"permission": "FULL_CONTROL"},{"grantee": {"uri": "http://acs.amazonaws.com/groups/global/AllUsers"},"permission": "FULL_CONTROL"},{"grantee": {"uri": "http://acs.amazonaws.com/groups/s3/LogDelivery"},"permission": "FULL_CONTROL"},{"grantee": {"id": "{{X-VMWARE-VOSE-USER-CONTEXT}}"},"permission": "FULL_CONTROL"}],"owner": {"id": "{{canonical_id}}","displayName": "{{displayName}}"}}'

    ACL_AUTHENTICATED_USER = '{"grants": [{"grantee": {"uri": "http://acs.amazonaws.com/groups/global/AuthenticatedUsers"},"permission": "{{granted_permission}}"}], "owner": {"id": "{{canonical_id}}", "displayName": "{{displayName}}"}}'

    ACL_PUBLIC_USER = '{"grants": [{"grantee": {"uri": "http://acs.amazonaws.com/groups/global/AllUsers"},"permission": "{{granted_permission}}"}],"owner": {"id": "{{canonical_id}}","displayName": "{{displayName}}"}}'

    ACL_SYSTEM_LOGGER = '{"grants": [{"grantee": {"uri": "http://acs.amazonaws.com/groups/s3/LogDelivery"},"permission": "{{granted_permission}}"}],"owner": {"id": "{{canonical_id}}","displayName": "{{displayName}}"}}'

    ACL_TENANT_USER = '{"grants": [{"grantee": {"id": "{{X-VMWARE-VOSE-USER-CONTEXT}}"},"permission": "{{granted_permission}}"}],"owner": {"id": "{{canonical_id}}","displayName": "{{displayName}}"}}'

    # AccessControlPolicy = {
    #     'Grants': [
    #         {
    #             'Grantee': {
    #                 'DisplayName': '{{display_name}}',
    #                 'EmailAddress': '{{email_address}}',
    #                 'ID': '{{id}}',
    #                 'Type': 'CanonicalUser' | 'AmazonCustomerByEmail' | 'Group',
    #                 'URI': 'string'
    #             },
    #             'Permission': 'FULL_CONTROL' | 'WRITE' | 'WRITE_ACP' | 'READ' | 'READ_ACP'
    #         },
    #     ],
    #     'Owner': {
    #         'DisplayName': 'string',
    #         'ID': 'string'
    #     }
    # }

    @staticmethod
    def get_bucket_access_control_policy(**kwargs):
        for key, value in kwargs.items():
            if key == 'owner_display_name':
                owner_display_name = value
            elif key == 'owner_id':
                owner_id = value
            if key == 'grantee_display_name':
                grantee_display_name = value
            elif key == 'grantee_id':
                grantee_id = value
            elif key == 'grantee_type':
                grantee_type = value
            elif key == 'grantee_permission':
                grantee_permission = value
        AccessControlPolicy = {
            "Grants": [
                {
                    "Grantee": {
                        # 'DisplayName': grantee_display_name,
                        "EmailAddress": "",
                        "ID": grantee_id,
                        "Type": grantee_type,
                        "URI": ""
                    },
                    "Permission": grantee_permission
                },
                {
                    "Grantee": {
                        # 'DisplayName': grantee_display_name,
                        "EmailAddress": "",
                        "ID": owner_id,
                        "Type": grantee_type,
                        "URI": ""
                    },
                    "Permission": "FULL_CONTROL"
                }
            ],
            "Owner": {
                # 'DisplayName': owner_display_name,
                "ID": owner_id
            }
        }
        return AccessControlPolicy

    @staticmethod
    def get_bucket_acl_with_xml_format():
       pass

    @staticmethod
    def get_bucket_acl_for_all_users(**kwargs):
        for key, value in kwargs.items():
            if key == 'uri':
                uri = value
            elif key == 'grantee_type':
                grantee_type = value
            elif key == 'grantee_permission':
                grantee_permission = value
            elif key == 'owner_id':
                owner_id = value

        AccessControlPolicy = {
            'Grants': [
                {
                    'Grantee': {
                        'URI': uri,
                        'Type': grantee_type
                    },
                    'Permission': grantee_permission
                }
            ],
            'Owner': {
                # 'DisplayName': owner_display_name,
                'ID': owner_id
            }
        }
        return AccessControlPolicy
